function Zout = dipole

% Nx  = poet bunk ve smru osy diplu
% epr = relativn permitivita substrtu

global  h  jazyk  k0  xdis  i scrsz

handle=findobj('Tag','frekvence');
f=(str2num(get(handle,'String')))*1e9;

handle=findobj('Tag','delka');
A=str2num(get(handle,'String'));% dlka diplu

handle=findobj('Tag','sirka');
B=str2num(get(handle,'String'));% ka antnnho psku

handle=findobj('Tag','vyska');
h=str2num(get(handle,'String'));% vzdlenost od reflektrou

handle=findobj('Tag','permit');
epr=str2num(get(handle,'String')); % relativn permitivita substrtu

%close
texty=[{'Rozloen proudu'};
{'Current distribution'}];

lam = 3e8/f;    	   % vlnov dlka [m]
k0  = 2*pi/lam;      % vlnov slo [rad/m]
omg = k0*3e+8;       % hlov kmitoet [rad/m]

Nx  = 33;

A   = A*1e-3;        
B   = B*1.0e-3;      
h   = h*1e-3;       
a   = A/(Nx+1);      % dlka buky

mi0 = 4*pi*1e-7;     % permeabilita vakua [H/m]
ep0 = 8.854e-12;     % permitivita vakua [F/m]

Ne  =  6;            % poet len rozvoje skalrn Greenovy funkce
eta = (epr-1)/(epr+1);

alp = atan( B/a);    % vpoet integrl Green.funkc
stt = 2*a*log( tan( alp/2+pi/4)) - 2*B*log( tan( alp/2));

psi = zeros( Nx+2, Ne);
for m=1:(Nx+2)
  xdis = (m-1)*a;                  % vodorovn vzdlenost sted bunk
  if m==1
    psi( m, 1) = 2*dblquad( 'singular', -a/2, +a/2, 1e-10, B/2, 1e-3, 'quad');
    psi( m, 1) = psi( m, 1) + stt;
  else
    i = 0;
    psi( m, 1) = dblquad( 'regular', -a/2, +a/2, -B/2, B/2, 1e-3, 'quad');    
  end
  for i=1:Ne
    psi( m, i+1) = dblquad( 'regular', -a/2, +a/2, -B/2, B/2, 1e-3, 'quad');
  end
end
      
G   = ( psi(:,1) - psi(:,2))/(4*pi);
cf1 = (1-eta)/(j*omg*ep0*epr*a*B);
cf2 = j*omg*mi0*a/B;
                                    % vztah mezi proudy a naptmi
ix = 0;
Zxx = zeros( Nx, Nx);
for m=1:Nx                          % pes clov buky ve smru x
  ix = ix + 1;
  iy = 0;
  for o=1:Nx                        % pes zdrojov buky ve smru x
    dx  = abs( m-o);                % vzdlenost clov a zdrojov buky
    iy  = iy + 1;
    hlp = 2*psi( 1+dx,1) - psi( 1+abs(dx+1),1) - psi( 1+abs(dx-1), 1);
    for i=1:Ne
      inc = ( 2*psi(1+dx,i+1)-psi(1+abs(dx+1),i+1)-psi(1+abs(dx-1),i+1));
      hlp = hlp - (1+eta)*(-eta)^(i-1)*inc;
    end
    Zxx(ix,iy) = cf1*hlp/(4*pi) + cf2*G(1+dx,1);
  end
end

Y = inv( Zxx);                      % admitann matice
h1=figure('Position',[scrsz(3)/2-250 scrsz(4)/2-200 500 400],'Name',texty{jazyk,1},'NumberTitle','off');
plot( abs( Y(:,17)));       % proudov distribuce
xlabel('segment [-]');
ylabel('I [A]');

Zout = 1/Y( 17, 17);                % vstupn impedance
